<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Cus02500MetaXCustoRecalculado extends \Zeedhi\Framework\Controller\Report {
  protected $novoCodigo;
  protected $consplan;
  protected $servicoPorGrupo;
  protected $nrorg;
  protected $cdfilial;
  protected $nrConsPlan;
  protected $birtStrategy;
  protected $Listas;
  protected $environment;
  protected $connection;

  public function __construct($reportService, $novoCodigo, $consplan, $servicoPorGrupo, $birtStrategy, $Listas, $environment, $util, StoredProcedure $procedureConsplanGeral, $connection) {
    $this->novoCodigo                 = $novoCodigo;
    $this->consplan                   = $consplan;
    $this->servicoPorGrupo            = $servicoPorGrupo;
    $this->reportService              = $reportService;
    $this->birtStrategy               = $birtStrategy;
    $this->Listas                     = $Listas;
    $this->environment                = $environment;
    $this->util                       = $util;
    $this->procedureConsplanGeral     = $procedureConsplanGeral;
    $this->connection                 = $connection;
  } 
  
  protected $reportMapping = array (
    'CUS02500' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "CDTIPOCUSTO"               => "P_NRTIPOCUSTO",
        "NMTIPOCUSTO"               => "P_NMTIPOCUSTO",
        "LISTAFILIAISAGREGADAS"     => "L_FILIAL",
        "NRLISTA"                   => "L_SERVFILI",
        "dataInicial"               => "P_DTINICIAL",
        "dataFinal"                 => "P_DTFINAL",
        "IDESTOCAVEL"               => "P_IDESTOCAVEIS",
        "NRCONSPLAN"                => "P_NRCONSPLAN",
        "CDFILIAL"                  => "P_CDCENTRAL",
        "IDNAOESTOC"                => "P_IDNESTOCAVEIS",
        "NRORG"                     => "P_NRORG"
      )
    )
  );  
  
  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    $cdOperador = $this->environment->getCdOperador();
    
    $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    $row['NRORG'] = $this->environment->getNrorg();
    $row['NRLISTASERV'] = $this->util->insertLista($row['LISTASERVFILI']);
    $row['NRLISTA'] = $this->util->insertLista($row['LISTASERVFILI']);
    $row['NMTIPOCUSTO'] = substr($row['NMTIPOCUSTO'], 5);
    $row['LISTAFILIAISAGREGADAS'] = $this->util->insertLista($row['LISTAFILIAISAGREGADAS']);
    
    $procedure = new StoredProcedure($this->connection, 'CONSPLAN_GERAL');
    $procedure->addParam(new Param('P_NRLISTA',      Param::PARAM_INPUT,  $row['NRLISTASERV'],    Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT,  $row['dataInicial'],    Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT,  $row['dataFinal'],      Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_IDPRODUTOS',   Param::PARAM_INPUT,  'CFP',                  Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_IDSEPPRATO',   Param::PARAM_INPUT,  'N',                    Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT,  0,                      Param::PARAM_TYPE_INT));
    $procedure->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT,  'N',                    Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT,  '0',                    Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT,  'zzzzzzzzzz',           Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT,  $cdOperador,            Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_NRCONSPLANTH', Param::PARAM_INPUT,  'GERANOVCOD',           Param::PARAM_TYPE_STR));
    $procedure->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_OUTPUT, null,                   Param::PARAM_TYPE_STR, 10));
    
    $procedureResult = $procedure->execute();
    $row['NRCONSPLAN'] = $procedureResult["P_NRCONSPLAN"];
  }  
  
}